# Collects values for the specified field and outputs those for which
# there are only case differences.

package CaseDiffs 1.01;

use v5.16;
use strict;
use warnings;

our %callbacks = (
    pre     => undef,
    perfile => \&do_perfile,
    post    => \&do_postprocessing,
);

my $rows_seen = 0;
my (%names, %dups);

# Per-row callback function
sub do_perfile {
    my ($argref, $field, $row) = @_;

    # auto-vivify a hash entry with the cell's value as a key
    $names{$row->{$field}}++;

    $rows_seen++;
    return undef;
}

# Post-processing callback function
sub do_postprocessing {

    say "Post-processing callback; row_seen = $rows_seen";

    for (keys %names) {
	$dups{lc $_}++;
    }
    for (keys %dups) {
	print "Case difference: $_\n" if $dups{$_} > 1;
    }

    return;
};

1;
