# Copies the topmost value in each grouping within the view for the field(s)
# specified with -f.  This single value is saved per-grouping, where the grouping
# is defined by the keyfield column specified with --args | -a. 
# Null values are omitted.

package CopyFirst 1.00;

use v5.16;
use strict;
use warnings;

$DB::single = 1;

our %callbacks = (
    pre     => undef,
    perfile => \&do_perfile,
    post    => undef,
);

my %groups;

# Per-row callback function
sub do_perfile {
    my ($keyfield, $field, $row) = @_;

    $keyfield = lc $keyfield;

    if (exists $groups{$row->{$keyfield}} and exists $groups{$row->{$keyfield}}{$field}) {
	return $groups{$row->{$keyfield}}{$field} || undef;
    }

    $groups{$row->{$keyfield}}{$field} = $row->{$field}		if $row->{$field} ne '';
    return undef;
}

1;
