# Reverses one or more names in a list in the form of Last, First to First Last.
# Names already in First Last form ignored

package LastFirst2FirstLast 1.01;

use v5.16;
use strict;
use warnings;

our %callbacks = (
    pre     => undef,
    perfile => \&do_perfile,
    post    => undef,
);

# Per-row callback function
sub do_perfile {
    my ($argstr, $field, $row) = @_;

    $_ = $row->{$field};
    my @f;
    for (split /\s*;\s*/) {
	s/([^,]+),\s*(.+)/$2 $1/;
	push @f, $_;
    }

    return join '; ', @f;
}

1;
