# Corrects casing on names

## Juan Jose Montes de Oca
## Sam Spade
## Ace of Base
## The Beatles
## Annette Funicello & the Beach Boys
## Ḯgor

package NameCase 1.01;

use v5.16;
use strict;
use warnings;

our %callbacks = (
    pre     => undef,
    perfile => \&do_perfile,
    post    => undef,
);

# list of name components that should not be title-cased.
my %options = (
    var	=> {
	exceptions =>  'of de il and the',
    },
);

$DB::single = 1;

main::set_scriptlet_opts(\%options);

my @exceptions;
for (split /\s+/, $options{'var'}{'exceptions'}) {
    push @exceptions, $_;
}

# Per-row callback function
sub do_perfile {
    my ($argstr, $field, $row) = @_;

    my @f;
    while ($row->{$field} =~ /(\S+)/g) {
	my $w = $1;
	push @f, /^\Q$w\E$/ ~~ @exceptions ? 
	    lc $w :
	    ucfirst(substr($w, 0, 1)) . lc(substr($w, 1));		# Unicode-safe title-casing
    }

    return ucfirst join ' ', @f;
}

1;
