# The following swaps roles and artists from a list of the form role:Artist; role:Artist, ...
# It is assumed that role is lowercase, and contains only the letters a-z, space, or forwardslash.

package SwapRoles 1.01;

use v5.16;
use strict;
use warnings;

our %callbacks = (
    pre     => undef,
    perfile => \&do_perfile,
    post    => undef,
);

# Per-row callback function
sub do_perfile {
    my ($argstr, $field, $row) = @_;

    $row->{$field} =~ s/([a-z \/]+):(.+?)(; ?|$)/$2:$1$3/g;

    return $row->{$field};
}

1;
