# This is a simple sample scriptlet which you can use as a template.  For a complete description of scriptlets,
# see the scriptlet file SampleComplete.pm.
#
package SampleSimple 1.01;

use v5.16;
use strict;
use warnings;

our %callbacks = (
    pre     => undef,
    perfile => \&do_perfile,
    post    => undef,
);

# Per-row callback function
sub do_perfile {
    my ($argstr, $field, $row) = @_;

    # Example:  The following globally removes parenthesis surrounding some text, converting, for example,
    # "Buster (The Man) Browne" into "Buster The Man Browne".  Note that $field is the name in the field
    #  specified with -f, and $row->{$field} is its value.  If there are multiple -f options, do_perfile
    #  will be called for each of them, in the order they were specified on the command line.
    #
    #  Note: the perl code below is so trivial, that it it could have been supplied directly on the command
    #  line using the -e option instead, as in:
    #       -e 's/\(([^)]+)\)/$1/g'

    $row->{$field} =~ s/\(([^)]+)\)/$1/g;

    return $row->{$field};
}

1;
